Bug 1308561 - Review Request: sway - i3-compatible window manager for Wayland
Review Request: sway - i3-compatible window manager for Wayland
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Adam Miller
Fedora Extras Quality Assurance
:
Depends On: 1308480
Blocks:
  Show dependency treegraph
 
Reported: 2016-02-15 08:59 EST by Fabio Alessandro Locati
Modified: 2016-08-31 23:20 EDT (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-08-27 06:16:11 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
admiller: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description Fabio Alessandro Locati 2016-02-15 08:59:07 EST
Spec URL: https://fale.fedorapeople.org/rpms/sway.spec
SRPM URL: https://fale.fedorapeople.org/rpms/sway-0-1.20160214git016a774.fc23.src.rpm
Description: i3-compatible window manager for Wayland
Fedora Account System Username: fale
Comment 1 Fabio Alessandro Locati 2016-04-06 13:03:41 EDT
I've packaged the version 0.3 (current release):

SPEC: https://fale.fedorapeople.org/rpms/sway.spec
SRPM: https://fale.fedorapeople.org/rpms/sway-0.3-1.fc23.src.rpm
Comment 2 Fabio Alessandro Locati 2016-05-06 11:41:29 EDT
I've updated to last released version:

SPEC: https://fale.fedorapeople.org/rpms/sway.spec
SRPM: https://fale.fedorapeople.org/rpms/sway-0.6-1.fc23.src.rpm
Comment 3 Fabio Alessandro Locati 2016-05-29 11:30:08 EDT
I've updated to v0.7:

SPEC: https://fale.fedorapeople.org/rpms/sway.spec
SRPM: https://fale.fedorapeople.org/rpms/sway-0.7-1.fc23.src.rpm
Comment 4 Fabio Alessandro Locati 2016-07-07 05:32:04 EDT
I've updated to v0.8:

SPEC: https://fale.fedorapeople.org/rpms/sway.spec
SRPM: https://fale.fedorapeople.org/rpms/sway-0.8-1.fc24.src.rpm

Thanks Adam for picking this review up :)
Comment 5 Adam Miller 2016-07-07 09:37:41 EDT
Not a formal review yet, waiting on wlc to land in rawhide before starting that.

However, I see that this "Requires ffmpeg" and ffmpeg isn't in Fedora and I'm not entirely sure it can be because of patents. We might need to check with legal.

Is ffmpeg a hard requirement?

-AdamM
Comment 6 Johannes Pfrang 2016-07-07 09:45:08 EDT
In the AUR PKGBUILD [1] (maintained by the primary sway developer) ImageMagick and ffmpeg are optional dependencies, which should probably translate to 'Suggests' in SPEC.

[1] https://aur.archlinux.org/cgit/aur.git/tree/PKGBUILD?h=sway-git
Comment 7 Fabio Alessandro Locati 2016-07-07 10:29:17 EDT
ImageMagick and ffmpeg should indeed be suggested instead of required.

ImageMagick is required for image capture with swaygrab, while ffmpeg is required for video capture with swaygrab.
Maybe we could use Recommends instead of Suggests. 

I've created a new version integrating Johannes suggestion:

SPEC: https://fale.fedorapeople.org/rpms/sway.spec
SRPM: https://fale.fedorapeople.org/rpms/sway-0.8-2.fc24.src.rpm
Comment 8 Adam Miller 2016-07-11 10:42:42 EDT
Apologies for the delay, I'm unsure of how to proceed here as we don't have Guidelines for Weak Dependencies on things that are from third-party repositories. I've created a ticket with the Fedora Council on the topic and opened an email thread on the packaging list.

https://fedorahosted.org/council/ticket/61

https://lists.fedoraproject.org/archives/list/packaging@lists.fedoraproject.org/thread/6LLERBZU5JX5DW7XJX7FWXV36K5G7AZR/
Comment 9 Neal Gompa 2016-07-11 10:47:03 EDT
If you're going to use weak dependencies, avoid using Suggests/Enhances, since libsolv based dependency resolvers do not provide a way to trigger the installation of suggested packages (they are considered "hints" for Recommends/Supplements).
Comment 10 Neal Gompa 2016-07-11 10:47:47 EDT
Erk, they are also considered hints for Requires as well, to make it easier to select something that "Provides" something when there are multiple providers.
Comment 11 Fabio Alessandro Locati 2016-08-03 07:18:40 EDT
Hi,
New version is available:

SPEC: https://fale.fedorapeople.org/rpms/sway.spec
SRPM: https://fale.fedorapeople.org/rpms/sway-0.9-1.fc24.src.rpm
Koji: http://koji.fedoraproject.org/koji/taskinfo?taskID=15117172

I've also commented out the requirements for non-core packages so we can maybe move forward eventually adding them back if the Council decides to allow them.
Comment 12 Fabio Alessandro Locati 2016-08-08 18:59:03 EDT
I've improved a little bit the dependencies and so forth:


SPEC: https://fale.fedorapeople.org/rpms/sway.spec
SRPM: https://fale.fedorapeople.org/rpms/sway-0.9-2.fc24.src.rpm
Comment 13 Igor Gnatenko 2016-08-09 03:36:15 EDT
> Suggests:       xorg-x11-server-Xwayland
it doesn't make sense. convert to Recommends or drop.

>        -DCMAKE_BUILD_TYPE=Release \
drop this

>        -DCMAKE_INSTALL_PREFIX=/usr \
hardcoded paths, drop it.

>        -DCMAKE_INSTALL_SYSCONFDIR=%{_sysconfdir} \
drop it.

>        .
consider making out-of-tree build
Comment 14 Fabio Alessandro Locati 2016-08-09 05:04:56 EDT
(In reply to Igor Gnatenko from comment #13)
> > Suggests:       xorg-x11-server-Xwayland
> it doesn't make sense. convert to Recommends or drop.

Why?
Recomments does not make sense IMHO since it can work properly without xorg dependencies. Dropping it could be an idea (and was the situation before my last update) but I think it's worth pointing it out since some user could want to run X apps on it (without having the whole xorg installed).

> 
> >        -DCMAKE_BUILD_TYPE=Release \
> drop this

In the Sway documentation is suggested to use it. Is there some Fedora reason to not have it?

> >        -DCMAKE_INSTALL_SYSCONFDIR=%{_sysconfdir} \
> drop it.

In the Sway documentation is suggested to use it. Is there some Fedora reason to not have it?

> consider making out-of-tree build

What do you mean? Why should I consider makin out-of-tree build?
Comment 15 Igor Gnatenko 2016-08-09 05:16:37 EDT
(In reply to Fabio Alessandro Locati from comment #14)
> (In reply to Igor Gnatenko from comment #13)
> > > Suggests:       xorg-x11-server-Xwayland
> > it doesn't make sense. convert to Recommends or drop.
> 
> Why?
> Recomments does not make sense IMHO since it can work properly without xorg
> dependencies. Dropping it could be an idea (and was the situation before my
> last update) but I think it's worth pointing it out since some user could
> want to run X apps on it (without having the whole xorg installed).
Suggests means to prefer one package over the other, for example:
* Package: bar Provides: foo
* Package: baz Provides: foo
* Package: sway Suggests: bar
dnf install sway will install only sway.
now you do dnf install foo and most likely (it's too complicated process) "bar" instead of "baz" will be installed as sway has Suggests.
> 
> > 
> > >        -DCMAKE_BUILD_TYPE=Release \
> > drop this
> 
> In the Sway documentation is suggested to use it. Is there some Fedora
> reason to not have it?
because debuginfo will be broken, %cmake defines it as RelWithDebInfo.
> 
> > >        -DCMAKE_INSTALL_SYSCONFDIR=%{_sysconfdir} \
> > drop it.
> 
> In the Sway documentation is suggested to use it. Is there some Fedora
> reason to not have it?
defined by %cmake.
> 
> > consider making out-of-tree build
> 
> What do you mean? Why should I consider makin out-of-tree build?
because it's good practice.

> %prep
> ...
> mkdir %{_target_platform}
> %build
> pushd %{_target_platform}
>   %cmake ..
> popd
> %make_build -C %{_target_platform}
> %install
> %make_install -C %{_target_platform}
Comment 16 Fabio Alessandro Locati 2016-08-10 05:50:35 EDT
(In reply to Igor Gnatenko from comment #15)
> (In reply to Fabio Alessandro Locati from comment #14)
> > (In reply to Igor Gnatenko from comment #13)
> > > > Suggests:       xorg-x11-server-Xwayland
> > > it doesn't make sense. convert to Recommends or drop.
> > 
> > Why?
> > Recomments does not make sense IMHO since it can work properly without xorg
> > dependencies. Dropping it could be an idea (and was the situation before my
> > last update) but I think it's worth pointing it out since some user could
> > want to run X apps on it (without having the whole xorg installed).
> Suggests means to prefer one package over the other, for example:
> * Package: bar Provides: foo
> * Package: baz Provides: foo
> * Package: sway Suggests: bar
> dnf install sway will install only sway.
> now you do dnf install foo and most likely (it's too complicated process)
> "bar" instead of "baz" will be installed as sway has Suggests.

As discussed in chat with vondruch, your statement is not exact, since you are assuming that the usage (and abuse) done by libsolv is the only possible use, while it's not.

> > > >        -DCMAKE_INSTALL_SYSCONFDIR=%{_sysconfdir} \
> > > drop it.
> > 
> > In the Sway documentation is suggested to use it. Is there some Fedora
> > reason to not have it?
> defined by %cmake.

This is not true, in fact if I don't put it, my config file is not places in /etc/sway/config but in /usr/etc/sway/config


Thanks for the other tips, I have done a new build:

SPEC: https://fale.fedorapeople.org/rpms/sway.spec
SRPM: https://fale.fedorapeople.org/rpms/sway-0.9-3.fc24.src.rpm
Comment 17 Adam Miller 2016-08-19 16:07:27 EDT
It looks like everything I wanted cleaned up got cleaned up and since the external packages are left out pending the Council's decision, I'm inclined to approve. Apologies for the lag time on this.

APPROVED.
Comment 18 Gwyn Ciesla 2016-08-22 10:34:47 EDT
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/sway
Comment 19 Fedora Update System 2016-08-22 12:48:42 EDT
sway-0.9-3.fc23 has been submitted as an update to Fedora 23. https://bodhi.fedoraproject.org/updates/FEDORA-2016-4f53f0e6c9
Comment 20 Fedora Update System 2016-08-22 12:48:52 EDT
sway-0.9-3.fc25 has been submitted as an update to Fedora 25. https://bodhi.fedoraproject.org/updates/FEDORA-2016-88448e465a
Comment 21 Fedora Update System 2016-08-22 12:48:57 EDT
sway-0.9-3.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2016-ca479ecc25
Comment 22 Fedora Update System 2016-08-22 19:51:54 EDT
sway-0.9-3.fc25 has been pushed to the Fedora 25 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-88448e465a
Comment 23 Fedora Update System 2016-08-23 12:20:11 EDT
sway-0.9-3.fc23 has been pushed to the Fedora 23 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-4f53f0e6c9
Comment 24 Fedora Update System 2016-08-23 12:22:02 EDT
sway-0.9-3.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-ca479ecc25
Comment 25 Fedora Update System 2016-08-27 06:16:07 EDT
sway-0.9-3.fc25 has been pushed to the Fedora 25 stable repository. If problems still persist, please make note of it in this bug report.
Comment 26 Fedora Update System 2016-08-31 23:20:13 EDT
sway-0.9-3.fc24 has been pushed to the Fedora 24 stable repository. If problems still persist, please make note of it in this bug report.
Comment 27 Fedora Update System 2016-08-31 23:20:50 EDT
sway-0.9-3.fc23 has been pushed to the Fedora 23 stable repository. If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.